!=====================================================!
!                                                     !
!     This work is distributed under CC_BY_NC_SA      !
!                                                     !
! Created by Ruben M. Cabezon and Domingo Garcia-Senz !
!               ruben.cabezon@unibas.ch               !
!               domingo.garcia@upc.edu                !
!                                                     !
!                        (2017)                       !
!                                                     !
!=====================================================!
!                                                     !
!                SPHYNX: masscenter.f90               !
!                                                     !
! Calculates the center of mass.                      !
!=====================================================!

subroutine masscenter(n,dataini,datafin)
      
  USE parameters,only:a,dim,masa,cm,mtotal

  implicit none
  integer i,j,n
  DOUBLE PRECISION npart
  integer,intent(in)::dataini,datafin
  
  cm=0.d0
  mtotal=0.d0
  do j=1,dim
     do i=dataini,datafin
        cm(j)=cm(j)+a(i+(j-1)*n)*masa(i)
     enddo
  enddo
  do i=dataini,datafin
     mtotal=mtotal+masa(i)
  enddo
  do j=1,dim
     cm(j)=cm(j)/mtotal
  enddo
  
  return
end subroutine masscenter

